﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Reflection;
using System.Text;

namespace Expl.Auxiliary {
   public static class AttributeExtensions {
      /// <summary>
      /// Get Description attribute from Enum value
      /// <remarks>If Description attribute doesn't exist, return Enum value name</remarks>
      /// </summary>
      /// <param name="Value">Enum value</param>
      /// <returns>String description</returns>
      public static string GetDescription(Enum Value) {
         FieldInfo fi = Value.GetType().GetField(Value.ToString());
         DescriptionAttribute[] attributes = (DescriptionAttribute[])fi.GetCustomAttributes(typeof(DescriptionAttribute), false);
         return attributes.Length > 0 ? attributes[0].Description : Value.ToString();
      }

      public static string GetDescription(Type Ty) {
         object[] AttrList = Ty.GetCustomAttributes(typeof(DescriptionAttribute), false);
         if (AttrList.Length == 0) return Ty.ToString();
         var Attr = (DescriptionAttribute)AttrList[0];
         return Attr.Description;
      }
   }
}
