﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Expl.Auxiliary {
   public static class Calendar {
      // Quick lookup equivalents of f(m)
      private static int[] DOWLookup = { 0, 3, 3, 6, 1, 4, 6, 2, 5, 0, 3, 5 };
      private static int[] DOWLookupLeapYear = { 6, 2, 3, 6, 1, 4, 6, 2, 5, 0, 3, 5 };

      public static int GetDOW(int Year, int Month, int Day) {
         int ShortYear = Year % 100;
         int Century = Year / 100;

         return (
            5 * ShortYear / 4
            + ((Year % 4) == 0 ? DOWLookupLeapYear[Month-1] : DOWLookup[Month-1])
            + Day
            - 2 * (Century % 4)
            -1
         ) % 7;
      }

      // f(m)
      public static int fm(int Month, bool LeapYear) {
         return (
            (int)(3 + 2 * (int)(0.5 + 1.0 / Month) + (5.0 * Month + Month / 9.0) / 2)
            - (LeapYear ? (int)(0.5 + 1.0 / Month) : 0)
         ) % 7;
      }
   }
}
