using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Reflection;
using System.Text;

namespace Expl.Auxiliary {

   public static class ECDiagnostics {
      /// <summary>
      /// Get fully qualified method name of calling method/property from stack
      /// </summary>
      public static string ThisMethod {
         get {
            StackTrace st = new StackTrace();
            MethodBase method = st.GetFrame(1).GetMethod();
            return method.ReflectedType.ToString() + "." + method.Name;
         }
      }

      /// <summary>
      /// Get fully qualified method name of 2nd calling method/property from stack
      /// </summary>
      public static string CallingMethod {
         get {
            StackTrace st = new StackTrace();
            MethodBase method = st.GetFrame(2).GetMethod();
            return method.ReflectedType.ToString() + "." + method.Name;
         }
      }

      /// <summary>
      /// Write debug text and include the class and method name and time stamp.
      /// </summary>
      /// <param name="text">Text to write</param>
      public static void DebugText(string text) {
         MethodBase mb = new StackTrace().GetFrame(1).GetMethod();
         Debug.WriteLine(string.Format("{0}.{1},{2}: {3}", mb.ReflectedType.ToString(), mb.Name, DateTime.Now.ToString("HH:mm:ss.fff"), text));
      }
   }
}
