﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Xml;
using System.Xml.Serialization;

namespace Expl.Auxiliary {
   public static class Serialize {
      /// <summary>
      /// Serialize an object to XML with UTF-8 encoding
      /// </summary>
      /// <param name="subject">Object to serialize</param>
      /// <returns>UTF-8 encoded string</returns>
      public static string SerializeToXml(object Subject) {
         XmlSerializer serializer = new XmlSerializer(Subject.GetType());
         using (MemoryStream ms = new MemoryStream())
         using (XmlTextWriter xtw = new XmlTextWriter(ms, Encoding.UTF8)) {
            serializer.Serialize(xtw, Subject);
            return Encoding.UTF8.GetString(ms.GetBuffer());
         }
      }

      /// <summary>
      /// Deserialize an object from XML
      /// </summary>
      /// <param name="XmlString">Source XML string</param>
      /// <param name="ObjectType">Object type to deserialize to</param>
      /// <returns>Object instance</returns>
      public static object DeserializeFromXml(string XmlString, Type ObjectType) {
         XmlSerializer serializer = new XmlSerializer(ObjectType);
         using (TextReader r = new StringReader(XmlString)) {
            object o = serializer.Deserialize(r);
            r.Close();
            return o;
         }
      }

      public static byte[] BinarySerialize(object Subject) {
         var s = new MemoryStream();
         var Formatter = new BinaryFormatter();
         Formatter.Serialize(s, Subject);
         byte[] Data = s.GetBuffer();
         s.Close();
         return Data;
      }

      public static object BinaryDeserialize(Stream DataStream) {
         var Formatter = new BinaryFormatter();
         return Formatter.Deserialize(DataStream);
      }

      public static object BinaryDeserialize(byte[] Data) {
         var DataStream = new MemoryStream(Data);
         object o = BinaryDeserialize(DataStream);
         DataStream.Close();
         return o;
      }
   }
}
