﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace Expl.Itinerary {
   public static class Defaults {
      public static readonly DefaultScheduleItem[] DefaultSchedules = new DefaultScheduleItem[] {
         new DefaultScheduleItem("Every day", "Every day", "every T1.0:0:0 lasting T1.0:0:0"),
         new DefaultScheduleItem("Mondays", "Mondays", "every T7.0:0:0 since 2008-01-07 lasting T1.0:0:0"),
         new DefaultScheduleItem("Tuesdays", "Tuesdays", "every T7.0:0:0 since 2008-01-01 lasting T1.0:0:0"),
         new DefaultScheduleItem("Wednesdays", "Wednesdays", "every T7.0:0:0 since 2008-01-02 lasting T1.0:0:0"),
         new DefaultScheduleItem("Thursdays", "Thursdays", "every T7.0:0:0 since 2008-01-03 lasting T1.0:0:0"),
         new DefaultScheduleItem("Fridays", "Fridays", "every T7.0:0:0 since 2008-01-04 lasting T1.0:0:0"),
         new DefaultScheduleItem("Saturdays", "Saturdays", "every T7.0:0:0 since 2008-01-05 lasting T1.0:0:0"),
         new DefaultScheduleItem("Sundays", "Sundays", "every T7.0:0:0 since 2008-01-06 lasting T1.0:0:0"),
         new DefaultScheduleItem("Weekends", "Weekends", "every T7.0:0:0 since 2008-01-05 lasting T1.0:0:0, every T7.0:0:0 since 2008-01-06 lasting T1.0:0:0"),
         new DefaultScheduleItem("Weekdays", "Weekdays", "every T1.0:0:0 lasting T1.0:0:0 !& (every T7.0:0:0 since 2008-01-05 lasting T1.0:0:0, every T7.0:0:0 since 2008-01-06 lasting T1.0:0:0)"),
         new DefaultScheduleItem("Every hour", "Every hour", "every T1:0:0 lasting T1:0:0"),
         new DefaultScheduleItem("Every 30 minutes", "Every 30 minutes", "every T30:0 lasting T30:0"),
         new DefaultScheduleItem("Every 15 minutes", "Every 15 minutes", "every T15:0 lasting T15:0"),
         new DefaultScheduleItem("Every 5 minutes", "Every 5 minutes", "every T5:0 lasting T5:0"),
         new DefaultScheduleItem("Every minute", "Every minute", "every T1:0 lasting T1:0"),
         new DefaultScheduleItem("Every 30 seconds", "Every 30 seconds", "every T30 lasting T30"),
         new DefaultScheduleItem("Every 15 seconds", "Every 15 seconds", "every T15 lasting T15"),
         new DefaultScheduleItem("Every 10 seconds", "Every 10 seconds", "every T10 lasting T10"),
         new DefaultScheduleItem("Every 5 seconds", "Every 5 seconds", "every T5 lasting T5"),
         new DefaultScheduleItem("Every second", "Every second", "every T1 lasting T1")
      };
   }

   public struct DefaultScheduleItem {
      private string _Name, _Description, _TDL;

      public DefaultScheduleItem(string Name, string Description, string TDL) {
         _Name = Name;
         _Description = Description;
         _TDL = TDL;
      }

      public string Name { get { return _Name; } }
      public string Description { get { return _Description; } }
      public string TDL { get { return _TDL; } }
   }
}
