﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace Expl.Itinerary {
   [Description("Limit")]
   public class LimitSchedule : IFilterSchedule {
      protected DateTime _LimitStart, _LimitEnd;
      protected TimedEvent _LimitEvent;
      protected ISchedule _Schedule;

      /// <summary>
      /// Default constructor
      /// </summary>
      public LimitSchedule()
         : this(DateTime.MinValue, DateTime.MaxValue, new VoidSchedule()) { }

      /// <summary>
      /// Constructor
      /// </summary>
      /// <param name="LimitStart">Start time</param>
      /// <param name="LimitEnd">End time</param>
      /// <param name="Schedule">Schedule</param>
      public LimitSchedule(DateTime LimitStart, DateTime LimitEnd, ISchedule Schedule) {
         _LimitStart = LimitStart;
         _LimitEnd = LimitEnd;
         _LimitEvent = new TimedEvent(_LimitStart, _LimitEnd);
         _Schedule = Schedule;
      }

      public void Dispose() {
         _LimitEvent = null;
         _Schedule = null;
      }

      public override string ToString() {
         return string.Format("{0} <= ({1}) < {2}", _LimitStart, _Schedule.ToString(), _LimitEnd);
      }

      public ISchedule BaseSchedule {
         get { return _Schedule; }
      }

      public int MinSchedules {
         get { return 1; }
      }

      public int MaxSchedules {
         get { return 1; }
      }

      public DateTime LimitStart {
         get { return _LimitStart; }
      }

      public DateTime LimitEnd {
         get { return _LimitEnd; }
      }

      public IEnumerable<TimedEvent> GetRange(DateTime RangeStart, DateTime RangeEnd) {
         yield break;
      }
   }
}
