﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace Expl.Itinerary {
   [Description("Offset")]
   public class OffsetSchedule : IFilterSchedule {
      protected ISchedule _Schedule;
      protected TimeSpan _OffsetTime;

      /// <summary>
      /// Default constructor
      /// </summary>
      public OffsetSchedule()
         : this(TimeSpan.Zero, new VoidSchedule()) { }

      /// <summary>
      /// Constructor
      /// </summary>
      /// <param name="OffsetTime">TimeSpan of offset</param>
      /// <param name="Schedule">Schedule to filter</param>
      public OffsetSchedule(TimeSpan OffsetTime, ISchedule Schedule) {
         _OffsetTime = OffsetTime;
         _Schedule = Schedule;
      }

      public void Dispose() {
         _Schedule = null;
      }

      public override string ToString() {
         return string.Format("{0} {1} {2}", _Schedule.ToString(), _OffsetTime.Ticks >= 0 ? "+" : "-", ItineraryConvert.ToString(_OffsetTime));
      }

      public ISchedule BaseSchedule {
         get { return _Schedule; }
      }

      public TimeSpan OffsetTime {
         get { return _OffsetTime; }
      }

      public IEnumerable<TimedEvent> GetRange(DateTime RangeStart, DateTime RangeEnd) {
         yield break;
      }
   }
}
