﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Expl.Itinerary {
   public class RepeatSchedule : IFilterSchedule {
      protected ISchedule _Schedule;
      protected int _RepeatCount;

      /// <summary>
      /// Default constructor
      /// </summary>
      public RepeatSchedule()
         : this(1, new VoidSchedule()) { }

      /// <summary>
      /// Constructor
      /// </summary>
      /// <param name="RepeatCount">Repeat count</param>
      /// <param name="Schedule">Schedule to repeat</param>
      public RepeatSchedule(int RepeatCount, ISchedule Schedule) {
         _Schedule = Schedule;
         _RepeatCount = RepeatCount;
      }

      public void Dispose() {
         _Schedule = null;
      }

      public override string ToString() {
         return string.Format("{0} x {1:d}", _Schedule.ToString(), _RepeatCount);
      }

      public ISchedule BaseSchedule {
         get { return _Schedule; }
      }

      public int RepeatCount {
         get { return _RepeatCount; }
      }

      public IEnumerable<TimedEvent> GetRange(DateTime RangeStart, DateTime RangeEnd) {
         yield break;
      }
   }
}
