using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Net.NetworkInformation;
using System.Text;
using Expl.Auxiliary;
using Expl.Itinerary;

namespace Expl.Itinerary.Tasks {

   /// <summary>
   /// No operation task
   /// Literally does nothing
   /// </summary>
   [ParametersTypeName("NOPTaskParameters")]
   public class NOPTask : ITask {
      public string Name { get { return this.GetType().ToString(); } }

      public TaskResult Execute(TimedEvent Event, ITaskParameters Parameters) {
         NOPTaskParameters p = Parameters as NOPTaskParameters;

         System.Threading.Thread.Sleep(1000);

         TaskResult result = new TaskResult();
         result.Status = TaskStatusLevel.OK;

         ECDiagnostics.DebugText(string.Format("{0} executed.", this.GetType().ToString()));

         return result;
      }
   }

   /// <summary>
   /// Parameters entity for NOPTask
   /// </summary>
   [Serializable]
   public class NOPTaskParameters : ITaskParameters { }

}
