﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using Expl.Itinerary;
using Antlr.Runtime;

namespace TestAntlr_3._1 {
   class Program {
      static void Main(string[] args) {

         // Valid input, no exception is thrown
         try {
            ParseTest("every T10");
         }
         catch (System.Exception ex) {
            Debug.WriteLine(string.Format("{0}: {1}", ex.GetType().ToString(), ex.Message));
         }

         // Invalid input triggers NoViableAltException, but is handled by catch block
         try {
            ParseTest("foobar");
         }
         catch (System.Exception ex) {
            Debug.WriteLine(string.Format("{0}: {1}", ex.GetType().ToString(), ex.Message));
         }

         // Semicolon in input triggers unhandled NoViableAltException despite catch block
         try {
            ParseTest("foobar;");
         }
         //catch (System.Exception ex) {
         //   Debug.WriteLine(string.Format("{0}: {1}", ex.GetType().ToString(), ex.Message));
         //}
         catch {
            Debug.WriteLine("Handled exception");
         }

         Console.WriteLine("Success!");
      }

      private static void ParseTest(string Text) {
         ICharStream input = new ANTLRStringStream(Text);
         TimeDefLexer lex = new TimeDefLexer(input);
         CommonTokenStream tokens = new CommonTokenStream(lex);
         TimeDefParser parser = new TimeDefParser(tokens);

         // Call 'prog' parser rule
         TimeDefParser.prog_return prog_ret = parser.prog();
         return;
      }
   }
}
